﻿package  {
	import flash.geom.Point;
	import flash.utils.ByteArray;
	import org.flixel.FlxBlock;
	import org.flixel.FlxCore;
	import org.flixel.FlxG;
	import org.flixel.FlxLayer;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	import org.flixel.FlxTilemap;
	
	public class PlayState extends FlxState {
		
		[Embed(source = "../data/tiles2.png")] private var ImgTiles:Class;
		[Embed(source = "../data/map7.txt", mimeType = "application/octet-stream")] private var DataMap:Class;
		
		[Embed(source = "../data/obj/obja.png")] private var ImgObjA:Class;
		[Embed(source = "../data/obj/objb.png")] private var ImgObjB:Class;
		[Embed(source = "../data/obj/objc.png")] private var ImgObjC:Class;
		[Embed(source = "../data/obj/objd.png")] private var ImgObjD:Class;
		[Embed(source = "../data/obj/obje.png")] private var ImgObjE:Class;
		[Embed(source = "../data/obj/objf.png")] private var ImgObjF:Class;
		[Embed(source = "../data/obj/objg.png")] private var ImgObjG:Class;
		[Embed(source = "../data/obj/objh.png")] private var ImgObjH:Class;
		[Embed(source = "../data/obj/obji.png")] private var ImgObjI:Class;
		
		private const theFont:String = "Plink";
		private const _OBJ_COLOR:uint = 0xffffff;
		
		private var _player:Player;
		private var _map:FlxTilemap;
		
		private var objA:FlxSprite;
		private var objB:FlxSprite;
		private var objC:FlxSprite;
		private var objD:FlxSprite;
		private var objE:FlxSprite;
		private var objF:FlxSprite;
		private var objG:FlxSprite;
		private var objH:FlxSprite;
		private var objI:FlxSprite;
		
		public static var layerStage:FlxLayer;
		public static var layerSprites:FlxLayer;
		public static var layerTexts:FlxLayer;
		
		public function PlayState() {
			trace("play state");
			
			super();
			
			layerStage = new FlxLayer;
			layerSprites = new FlxLayer;
			layerTexts = new FlxLayer;
			
			// player position (CHEAT)
			if (FlxG.debug) _player = new Player(mapPos(3, 7), mapPos(1, 14));
			else _player = new Player(578, 458);
			layerSprites.add(_player);
			
			_map = new FlxTilemap(ByteArray(new DataMap).toString(), ImgTiles, 8, 18);
			layerStage.add(_map);
			
			// texts
			addText(mapPos(5, 1), mapPos(4, 2), "climbrunner\ra game by agj\rfor ludum dare 16");
			
			addText(mapPos(5, 1), mapPos(5, 3), "well now,\rwhere did i put it?");
			
			addText(mapPos(4, 1), mapPos(5, 1), "is this\rwhat i\rforgot?");
			addText(mapPos(3, 1), mapPos(1, 1), "is this the one?");
			addText(mapPos(4, 10), mapPos(1, 1), "or is it this one?");
			addText(mapPos(2, 1), mapPos(4, 1), "hmmm...");
			addText(mapPos(7, 1), mapPos(2, 6), "was i searching for this?");
			addText(mapPos(7, 1), mapPos(5, 1), "is this mine?");
			addText(mapPos(2, 1), mapPos(7, 8), "might this one be it?");
			addText(mapPos(6, 1), mapPos(8, 1), "i wonder...");
			//addText(mapPos(, ), mapPos(, ), "");
			
			// objects
			addObject(ImgObjH, objA, mapPos(3, 11), mapPos(1, 6));
			addObject(ImgObjI, objB, mapPos(4, 6), mapPos(1, 6));
			addObject(ImgObjC, objC, mapPos(1, 5), mapPos(2, 7));
			addObject(ImgObjD, objD, mapPos(7, 8), mapPos(2, 10));
			addObject(ImgObjE, objE, mapPos(2, 5), mapPos(4, 5));
			addObject(ImgObjF, objF, mapPos(4, 10), mapPos(5, 9)); // first, near start
			addObject(ImgObjG, objG, mapPos(7, 6), mapPos(5, 9));
			addObject(ImgObjA, objH, mapPos(2, 7), mapPos(7, 11));
			addObject(ImgObjB, objI, mapPos(6, 9), mapPos(8, 6));
			
			add(layerSprites);
			add(layerStage);
			add(layerTexts);
		}
		
		override public function update():void {
			super.update();
			
			_map.collide(_player);
			
			// camera
			FlxG.scroll.x = -128 * Math.floor((_player.x + 3) / 128);
			FlxG.scroll.y = -128 * Math.floor((_player.y + 3) / 128);
		}
		
		private function mapPos(Room:int, Block:int):int {
			return (Room - 1) * 128 + (Block - 1) * 8;
		}
		
		private const _NUDGE_OBJECT:int = 5;
		private function addObject(graphic:Class, object:FlxSprite, PosX:int, PosY:int):void {
			object = FlxSprite(layerTexts.add(new FlxSprite(graphic, PosX + _NUDGE_OBJECT, PosY + _NUDGE_OBJECT)));
			object.scale.x = 2, object.scale.y = 2, object.color = _OBJ_COLOR;
		}
		private const _NUDGE_TEXT:Point = new Point(0, 0);
		private function addText(PosX:int, PosY:int, Text:String):void {
			var text:FlxText = FlxText(layerTexts.add(new FlxText(PosX + _NUDGE_TEXT.x, PosY + _NUDGE_TEXT.y, 128, Text, 0x000000, theFont, 8)));
		}
		
	}
	
}